Keys_Left equ $01
Keys_Right equ $02
Keys_Up equ $04
Keys_Down equ $08
Keys_Dir equ $0f
Keys_Button0 equ $10
Keys_Button1 equ $20

PaperEmpty equ $08

dseg
LastKey:
    defb 0
JoystickAvailable_:  public JoystickAvailable_
    defb 0
PrinterPortAvailable:
    defb 0

cseg
InitKey: public InitKey
    clr JoystickAvailable_
    clr LastKey

    clr $FD01
    lda $FD02
                                ; lll:bra lll
    anda #PaperEmpty
    sta PrinterPortAvailable
rts


KeyHandler: public KeyHandler
    lda $FD01 | sta LastKey
rts


PrinterTable:
    defb $fe,Keys_Right
    defb $fd,Keys_Left
    defb $fb,Keys_Up
    defb $f7,Keys_Down
    defb $ef,Keys_Button1
    defb $df,Keys_Button0
    defb 0

ReadPrinterPort:
    ldx #PrinterTable
    do
        lda ,x+
    while ne
        sta $FD01
        lda $FD02
        bita #PaperEmpty
        if eq
            orb ,x
        endif
        leax 1,x
    wend
rts


KeyTable:
    defb $09,Keys_Button1
    defb ' ',Keys_Button0 
    defb '1',Keys_Down or Keys_Left
    defb '2',Keys_Down
    defb '3',Keys_Down or Keys_Right
    defb '4',Keys_Left
    defb '6',Keys_Right
    defb '7',Keys_Button0 or Keys_Left
    defb '8',Keys_Up
    defb '9',Keys_Button0 or Keys_Right
    defb 25,Keys_Right
    defb 24,Keys_Left
    defb 22,Keys_Up
    defb 23,Keys_Down
    defb 'z',Keys_Button0 or Keys_Left
    defb 'x',Keys_Button0 or Keys_Right
    defb 'Z',Keys_Button0 or Keys_Left
    defb 'X',Keys_Button0 or Keys_Right
    defb 0
ScanKeys_: public ScanKeys_
    pshs b,x
        clrb
        tst PrinterPortAvailable
        if ne
            bsr ReadPrinterPort
        endif
        tfr b,a
        tsta
        if ne
            ldb #1
            stb JoystickAvailable_
            bra ScanKeys_exit
        endif

        tst JoystickAvailable_
        if eq
            ldb LastKey
            ldx #KeyTable
            do
                lda ,x
            while ne
                cmpb ,x
                if eq
                    lda 1,x
                    bra ScanKeys_exit
                endif
                leax 2,x
            wend
        endif
        clra
        ; tfr b,a
ScanKeys_exit:
    puls b,x
rts
